﻿using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using Office = Microsoft.Office.Core;
using static Demo.Library;

namespace Demo.Addin
{

    public partial class ThisAddIn
    {

        private readonly ThisRibbon myRibbon = new();
        private readonly ThisData myData = new ();

        protected override Office.IRibbonExtensibility CreateRibbonExtensibilityObject()
        {
            return myRibbon;
        }

        protected override object RequestComAddInAutomationService()
        {
            return myData;
        }

        private void ThisAddIn_Startup(object sender, EventArgs e)
        {
            Debug.Print("Addin:Startup");
        }
        private void ThisAddIn_Shutdown(object sender, EventArgs e)
        {
            DisposeLib();
            Dispose();
            Debug.Print($"Addin:ShutDown:Complete");
        }

        [ComVisible(true)]
        public class ThisRibbon : Office.IRibbonExtensibility
        {

            internal Office.IRibbonUI xlRibbon;

            public string GetCustomUI(string ribbonID)
            {
                return My.Resources.Resources.ribbonXML;
            }

            public void OnLoad(Office.IRibbonUI ribbon)
            {
                // Store the reference to user's entire ribbon
                xlRibbon = ribbon;
                xlRibbon.ActivateTabMso("TabAddIns");
            }

            public void ShowUI(Office.IRibbonControl control)
            {
                switch (control.Id ?? "")
                {
                    case "DemoButton":
                        {
                            Show(Globals.ThisAddIn.Application);
                            break;
                        }
                }
            }
        }

        [ComVisible(true)]
        public class ThisData
        {
            // This class is exposed when calling .ComAddins('DpiDemo').Object"
            public string Hello { get; set; } = "DpiDemo says Hi!";
        }
    }
}