﻿using System;
using System.Diagnostics;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using static Demo.Library;
using static Demo.Win32;

namespace Demo.App
{
    public static class MainModule
    {
        [STAThread]
        public static void Main(params string[] args)
        {
            Debug.Print("Args:");

            if (args.Any())
            {
                foreach (var arg in args)
                    Debug.Print(arg);
            }
            else
            {
                Debug.Print("nope");
            }

            // Note: See Comments in Library.EnsureAwareness
            // But when we create our own AppDomain we CAN set ProcessDpiAwareness directly.
            var pa = new PROCESS_DPI_AWARENESS[2];
            int[] rGet = new int[2], rSet = new int[2];
            rGet[0] = GetProcessDpiAwareness(IntPtr.Zero, out pa[0]);
            rSet[1] = SetProcessDpiAwareness(PROCESS_DPI_AWARENESS.PROCESS_PER_MONITOR_DPI_AWARE);
            rGet[1] = GetProcessDpiAwareness(IntPtr.Zero, out pa[1]);
            var pc = GetDpiData();
            Debug.Print($"Exe:Main {pa[0]}->{pa[1]} It aint v2 yet! {pc.Process}");
            EnsureAwareness();

            if (!args.Any())
            {
                // Show library's current mainwindow
                Show(default);
                Application.Current.Run(new Demo.AppWindow());
            }
            else
            {
                EnsureApp();
                EnsureData();
                IsHosted = false;
                EnsureAwareness();
                Application.Current.MainWindow = new Demo.PlainWindow();
                Application.Current.MainWindow.Show();
                Application.Current.Run(new Demo.AppWindow() { Background = Brushes.Magenta });
            }


        }

        public static void ShutDown()
        {
            Application.Current.Dispatcher.InvokeShutdown();
        }






    }
}