﻿using System.Windows;
using System.Windows.Controls;
using System.ComponentModel;

namespace Demo
{

    public partial class PlainWindow: Window
    {

        private DpiHelper dh;
        private FocusHelper fc;

        public PlainWindow()
        {
            DataContext = Library.ViewModel;
            Library.EnsureResources();
            InitializeComponent();
            if (Library.AllowDpiHelper && Library.IsHosted)
                dh = new DpiHelper(this);
            if (Library.AllowFocusHelper)
                fc = new FocusHelper(this);
            Closing += PlainWindow_Closing;
        }

        private void PlainWindow_Closing(object sender, CancelEventArgs e)
        {
            if (IsVisible)
            {
                e.Cancel = true;
                Hide();
            }
        }
    }
}